var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

const React = require('react');
const Component = React.Component;
const { connect } = require('react-redux');
const { bridge } = require('electron').remote.require('./bridge');

class NavigatorComponent extends Component {
	componentWillReceiveProps(newProps) {
		if (newProps.route) {
			const screenInfo = this.props.screens[newProps.route.routeName];
			let windowTitle = ['Joplin'];
			if (screenInfo.title) {
				windowTitle.push(screenInfo.title());
			}
			this.updateWindowTitle(windowTitle.join(' - '));
		}
	}

	updateWindowTitle(title) {
		try {
			if (bridge().window()) bridge().window().setTitle(title);
		} catch (error) {
			console.warn('updateWindowTitle', error);
		}
	}

	render() {
		if (!this.props.route) throw new Error('Route must not be null');

		const route = this.props.route;
		const screenProps = route.props ? route.props : {};
		const screenInfo = this.props.screens[route.routeName];
		const Screen = screenInfo.screen;

		const screenStyle = {
			width: this.props.style.width,
			height: this.props.style.height
		};

		return React.createElement(
			'div',
			{ style: this.props.style },
			React.createElement(Screen, _extends({ style: screenStyle }, screenProps))
		);
	}
}

const Navigator = connect(state => {
	return {
		route: state.route
	};
})(NavigatorComponent);

module.exports = { Navigator };
